\usepgfplotslibrary{fillbetween}

\begin{tikzpicture}
	\begin{axis}[
		axis lines=middle,
		xlabel={$x$},
		ylabel={$y$},
		xmin=-2,
		xmax=2,
		ymin=-1,
		ymax=4,
	]
		\addplot[
			name path=linear,
			domain=-2:2,  % domain needs to be explicity added for arrows
			{latex}-{latex},
			% Since this is a linear function,
			% only the end points need to be sampled
			samples=2,
		] {1} node [pos=0.85, below, anchor=north west] {$y = 1$};

		\addplot[
			name path=quadratic,
			domain=-2:2,
			{latex}-{latex},
		] {x^2} node [near end, right] {$y = x^2$};

		% Fill area between paths
		\addplot[blue!50, opacity=0.50]
			fill between [of=linear and quadratic, soft clip={domain=-1:1}];
	\end{axis}
\end{tikzpicture}
